// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Mode.h"

#include "MainFrm.h"

#include "ModeDoc.h"
#include "ModeView.h"
#include "SetStepsDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_DELETE, OnEditDelete)
	ON_COMMAND(ID_TOOLS_SETSTEPS, OnToolsSetsteps)
	ON_COMMAND(ID_TOOLS_GENERATE3DMODEL, OnToolsGenerate3dmodel)
	ON_COMMAND(ID_EDIT_MOVEPOINT, OnEditMovepoint)
	ON_UPDATE_COMMAND_UI(ID_EDIT_MOVEPOINT, OnUpdateEditMovepoint)
	ON_COMMAND(ID_EDIT_INSERTPOINT, OnEditInsertpoint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_COORD,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// configura barra de status
	// alarga o segundo espaco de mensagens da barra de status para caber coordenadas
	m_wndStatusBar.SetPaneInfo ( 1, indicators [ 1 ], m_wndStatusBar.GetPaneStyle ( 1 ), 130 );
	// altera barra de status para exibir coordenadas
	CString
		oszXY;
	oszXY.LoadString ( ID_INDICATOR_COORD );
	CStatusBarCtrl
		&oStatusBar = m_wndStatusBar.GetStatusBarCtrl ();
	oStatusBar.SetText( oszXY, 1, 0 );

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnEditDelete() 
{
	//	apaga ultimo ponto inserido no shape ou ponto selecionado

	// acessa documento
	CModeDoc
		*poDoc = (CModeDoc*) GetActiveDocument ();
	
	// verifica se documento nao esta vazio
	if ( poDoc->m_adwX.GetSize () != 0 ) {

		// verifica se deve apagar ponto inserido ou selecionado
		if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover == FALSE ) {
			// apaga ultimo elemento das matrizes
			poDoc->m_adwX.RemoveAt ( poDoc->m_adwX.GetSize () - 1 );
			poDoc->m_adwY.RemoveAt ( poDoc->m_adwY.GetSize () - 1 );
		}
		else
			// verifica se existe ponto selecionado
			if ( ( (CModeView*) GetActiveView () ) -> m_nPSel != -1 ) {
				// apaga ponto selecionado
				poDoc->m_adwX.RemoveAt ( ( (CModeView*) GetActiveView () ) -> m_nPSel );
				poDoc->m_adwY.RemoveAt ( ( (CModeView*) GetActiveView () ) -> m_nPSel );
				// verifica nao se haviam mais pontos apohs o apagado
				if ( ( (CModeView*) GetActiveView () ) -> m_nPSel == poDoc->m_adwX.GetSize () )
					( (CModeView*) GetActiveView () ) -> m_nPSel = -1;
			}
			else {
				AfxMessageBox ( IDS_SELECTPOINT );
				return;
			}

		// documento alterado
		poDoc->SetModifiedFlag ( TRUE );  // documento alterado
		poDoc->UpdateAllViews ( NULL );
	}
	else
		MessageBeep ( MB_ICONEXCLAMATION );

}

void CMainFrame::OnToolsSetsteps() 
{
	// redefine numero de ocorrencias no shape no modelo 3D
	CSetStepsDlg
		oCx;
	oCx.DoModal ();	
}

void CMainFrame::OnToolsGenerate3dmodel() 
{
	// gera modelo 3D e grava em arquivo formato solido (*.S)

	// pede arquivo de saida
	// cria caixa de dialogo
	CFileDialog
		oCx ( FALSE, "*.s", NULL, OFN_OVERWRITEPROMPT,
	   		"Solido (*.s) | *.s | Todos Arquivos (*.*) | *.* ||",
	   		NULL );
	// mostra a caixa e se for teclado Cancel abortas operacao
	if ( oCx.DoModal () == IDCANCEL )
		return;

	// define nome do arquivo de solido
	CString
		oszArqS = oCx.GetPathName ();
	// define nome do arquivo de particao
	// retira extensao do nome de arquivo
	int
		nTamS = oszArqS.GetLength ();
	int
		nTamExt = ( oCx.GetFileExt () ).GetLength () + 1;
	CString
		oszArqPAR = oszArqS.Left ( nTamS - nTamExt );
	// define nome
	oszArqPAR += ".par";

	// acessa documento
	CModeDoc
		*poDoc = (CModeDoc*) GetActiveDocument ();

	// numero de ocorrencias do shape no modelo
	int
		nSteps = ( (CModeApp*) AfxGetApp () ) -> m_nSteps;

	// numero de pontos no shape
	int
		nNPontos = poDoc->m_adwX.GetSize ();

	// estruturas 3D com uma secao rotacionada
	CDWordArray
		adwX,
		adwY,
		adwZ;
	adwX.SetSize ( nNPontos );
	adwY.SetSize ( nNPontos );
	adwZ.SetSize ( nNPontos );
	// copia ys do documento - valores nao sao alterados na rotacao
	for ( int ncY = 0; ncY < nNPontos; ncY ++ )
		adwY [ ncY ] = poDoc->m_adwY [ ncY ];

	// numero PI
	float
		fPi = (float) 3.14159265359;

	// grava arquivo de solido

	// cria arquivo de solido
	CStdioFile
		oArqS;
	if( ! oArqS.Open( oszArqS, CFile::modeCreate | CFile::modeWrite | CFile::typeText ) ) {
		AfxMessageBox ( "Erro ao criar arquivo de solido." );
		return;
	}

	// grava cabecalho
	CString
		oszCab = "/* Modelado no Mode. Perfil usado: ";
	oszCab += poDoc->GetTitle ();
	oszCab += ". Numero de passos: ";
	char
		szN [ 200 ];
	sprintf ( szN, "%d */\n\n", nSteps );
	oszCab += szN;
	oArqS.WriteString ( oszCab );

	// grava numero de vertices e poligonos
	// vertices
	int
		nTotVert = nNPontos * nSteps;
	sprintf ( szN, "%d     /* numero de vertices */\n", nTotVert );
	oArqS.WriteString ( szN );
	// poligonos
	int
		nTotPol = ( nNPontos - 1 ) * nSteps;
	sprintf ( szN, "%d     /* numero de poligonos */\n\n", nTotPol );
	oArqS.WriteString ( szN );
	
	// inicio da secao de vertices
	oArqS.WriteString ( "V: /* vertices (x, y, z) */\n" );

	// grava vertices do solido
	// faz tantas rotacoes quanto eh o numero de steps, passos
	for ( int ncS = 0; ncS < nSteps; ncS ++ ) {

		// define angulo de rotacao conforme origem e step atual
		float
			fAng = 2 * fPi / nSteps * ncS;
		
		// rotaciona pontos conforme plano XZ
		for ( int ncRot = 0; ncRot < nNPontos; ncRot ++ ) {
			adwX [ ncRot ] = (int) ( (float) poDoc->m_adwX [ ncRot ] * cos ( fAng ) ) /*- poDoc->m_adwZ [ ncRot ] * sin ( fAng )*/;
			adwZ [ ncRot ] = (int) ( (float) /*poDoc->m_adwZ [ ncRot ] * cos ( fAng ) +*/ poDoc->m_adwX [ ncRot ] * sin ( fAng ) );
		}

		// grava cada conjunto de pontos do shape rotacionado
		for ( int ncP = 0; ncP < nNPontos; ncP ++ ) {
			// cria linha de texto com coordenadas
			char
				szL [ 200 ];
			sprintf ( szL, "   %+06d %+06d %+06d       /* %u",
				     (int) adwX [ ncP ], (int) adwY [ ncP ], (int) adwZ [ ncP ], (UINT) ( ncP + ncS * nNPontos ) );
			CString
				oszL = szL;
			// verifica se deve criar comentario sobre novo passo
			if ( ncP == 0 ) {
				char
					szPasso [ 200 ];
				sprintf ( szPasso, ", passo %u */\n", (UINT) ncS );
				oszL += szPasso;
			}
			else
				oszL += " */\n";
			// escreve no arquivo
			oArqS.WriteString ( oszL );
		}
	}
	
	// inicio da secao de poligonos
	oArqS.WriteString ( "\nP: /* poligonos (v1, v2, v3, v4) - vertices em ordem anti-horaria */\n" );

	// grava poligonos do solido
	// gera tantas colunas de poligonos quanto eh o numero de passos
	for ( int ncCol = 0; ncCol < nSteps; ncCol ++ ) 
		// grava cada poligono da coluna
		for ( int ncP = 0; ncP < nNPontos - 1; ncP ++ ) {

			// define coluna de pontos, shape, seguinte
			int
				nProx = ncCol + 1;
			// se estah alem da ultima coluna entao deve usar a primeira
			if ( nProx >= nSteps )
				nProx = 0;
			// define vertices do poligono (ordem horaria)
			int
				nV1 = ncP + nProx * nNPontos,
				nV2 = ncP + nProx * nNPontos + 1,
				nV3 = ncP + ncCol * nNPontos + 1,
				nV4 = ncP + ncCol * nNPontos;

			// Nao resolveu erro no visualizador
			// Bugfix: erro no visualizador - se pontos muito proximos vetor normal
			// nao eh calculado direito e superficie eh removida sem necessidade.
			// Solucao: (paleativo) se pontos estao sobre o eixo de rotacao nao
			// usar ponto rotacionado.
			// verifica algum dos vertices estah sobre eixo de rotacao (Y igual a 0)
			/*if ( poDoc->m_adwY [ nV1 ] == 0 ) 
				nV1 = ncP;         // usa vertice original, nao rotacionado
			if ( poDoc->m_adwY [ nV2 ] == 0 ) 
				nV2 = ncP + 1;     // usa vertice original, nao rotacionado
			if ( poDoc->m_adwY [ nV3 ] == 0 ) 
				nV3 = ncP + 1;     // usa vertice original, nao rotacionado
			if ( poDoc->m_adwY [ nV4 ] == 0 ) 
				nV4 = ncP;         // usa vertice original, nao rotacionado*/

			// grava vertices do poligono
			// cria linha de texto com vertices
			char
				szL [ 200 ];
			sprintf ( szL, "   %05d %05d %05d %05d       /* %u", nV4, nV3, nV2, nV1,
				      (UINT) ( ncP + ncCol * ( nNPontos - 1 ) ) );
			CString
				oszL = szL;
			// verifica se deve criar comentario sobre novo passo
			if ( ncP == 0 ) {
				char
					szPasso [ 200 ];
				sprintf ( szPasso, ", passo %u - %u */\n", (UINT) ncCol, (UINT) nProx );
				oszL += szPasso;
			}
			else
				oszL += " */\n";
			// escreve no arquivo
			oArqS.WriteString ( oszL );
		}

	// grava arquivo de particao
	
	// cria arquivo de particao
	CStdioFile
		oArqPAR;
	if( ! oArqPAR.Open( oszArqPAR, CFile::modeCreate | CFile::modeWrite | CFile::typeText ) ) {
		AfxMessageBox ( "Erro ao criar arquivo de particao." );
		return;
	}
	
	// grava numero de particoes
	oArqPAR.WriteString ( "00001     /* numero de particoes */\n\n" );

	// escreve texto da particao
	char
		szPar [ 200 ];
	sprintf ( szPar, "/* Particao 0, poligonos: 0 a %u, particao geral, vertices: */\n0  %u\n\n",
		     (UINT) ( nTotPol - 1 ), (UINT) ( nTotVert - 1 ) );
	oArqPAR.WriteString ( szPar );

	// indica fim
	MessageBeep ( MB_OK );
}



void CMainFrame::OnEditMovepoint() 
{
	// entra em modo para mover pontos ou para inserir (faz valor = NOT valor)
	( (CModeApp*) AfxGetApp () ) -> m_bMover = ! ( (CModeApp*) AfxGetApp () ) -> m_bMover;

	// define, no view, nenhum ponto selecionado
	( (CModeView*) GetActiveView () ) -> m_nPSel = -1;
	// atualiza view
	( (CModeDoc*) GetActiveDocument () ) -> UpdateAllViews ( NULL );

}



void CMainFrame::OnUpdateEditMovepoint(CCmdUI* pCmdUI) 
{
	// verifica se eh para por marca indicando modo de mover ponto
	if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover == TRUE )
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);	
}



void CMainFrame::OnEditInsertpoint() 
{
	// insere um ponto
	
	// verifica se estah em modo de alterar pontos, se nao avisa e aborta
	if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover == FALSE ) {
		AfxMessageBox ( IDS_SETMODE );
		return;
	}

	// verifica se havia algum ponto selecionado, se nao havia pede selecao
	if ( ( (CModeView*) GetActiveView () ) -> m_nPSel == -1 ) {
		AfxMessageBox ( IDS_SELECTPOINT );
		return;
	}

	// acessa documento
	CModeDoc
		*poDoc = (CModeDoc*) GetActiveDocument ();

	// define em qual posicao inserir novo ponto (insere antes do ponto selecionado)
	int
		nPNovo = ( (CModeView*) GetActiveView () ) -> m_nPSel;

	// define coordenadas do ponto (acima do ponto selecionado)
	int
		nX = poDoc->m_adwX [ nPNovo ],
		nY = poDoc->m_adwY [ nPNovo ] - 20;

	// verifica se coordenadas estao fora da area do universo
	if ( nY < - ( (CModeView*) GetActiveView () ) -> m_nYO ) {
		AfxMessageBox ( IDS_OUTSIDEUNIVERSE );
		return;
	}

	// insere ponto
	poDoc->m_adwX.InsertAt ( nPNovo, (DWORD) nX );
	poDoc->m_adwY.InsertAt ( nPNovo, (DWORD) nY );

	// documento alterado
	poDoc->SetModifiedFlag ( TRUE );  // documento alterado
	poDoc->UpdateAllViews ( NULL );
}
